package com.theitbulls.downloadfile;

import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.Toast;

import androidx.annotation.Nullable;
import androidx.appcompat.app.AppCompatActivity;
import androidx.appcompat.widget.AppCompatTextView;

public class MainActivity extends AppCompatActivity {
    private AppCompatTextView tvFileUrl;

    private BroadcastReceiver receiver = new BroadcastReceiver() {
        @Override
        public void onReceive(Context context, Intent intent) {
            Bundle bundle = intent.getExtras();
            if (bundle != null) {
                String fileUrl = bundle.getString(DownloadFileIntentService.URL);
                int resultCode = bundle.getInt(DownloadFileIntentService.RESULT);
                String msg = bundle.getString(DownloadFileIntentService.RESULT_MSG);
                if (resultCode == RESULT_OK) {
                    Log.d("FileLocation", fileUrl);
                    tvFileUrl.setText("File download completed\r\nFile Location:" + fileUrl);
                } else {
                    Log.d("FileError", msg);
                    Toast.makeText(MainActivity.this, msg, Toast.LENGTH_SHORT).show();
                }
            }
        }
    };

    @Override
    protected void onCreate(@Nullable Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main_activity);

        tvFileUrl = findViewById(R.id.tvFileUrl);
    }

    @Override
    protected void onResume() {
        super.onResume();
        registerReceiver(receiver, new IntentFilter(DownloadFileIntentService.DOWNLOAD_INTENT));
    }

    @Override
    protected void onDestroy() {
        super.onDestroy();
        unregisterReceiver(receiver);
    }

    public void download(View view) {
        Intent downloadIntent = new Intent(this, DownloadFileIntentService.class);
        downloadIntent.putExtra(DownloadFileIntentService.URL, "https://storage.googleapis.com/itbulls_tarun/6_1570049668145.jpg");
        downloadIntent.putExtra(DownloadFileIntentService.FILE_NAME, "6_1570049668145.jpg");
        downloadIntent.setAction(DownloadFileIntentService.DOWNLOAD_INTENT);

        startService(downloadIntent);

        tvFileUrl.setText("File download start, please wait...");
    }
}
